#ifndef RANGE_H
#define RANGE_H

/*****************************************************
 * range class
 ****************************************************/

class range {
private:
  int _start;
  int _stop;
  int _stride;

public:

  // supports construction such as range(3) for the singleton set {3}
  range(int start);

  // supports construction such as range(3,6), which includes values {3, 4, 5}
  range(int start, int stop);

  // supports construction such as range(3,2,8), which includes values {3, 5, 7}
  range(int start, int stride, int stop);

  // Returns starting index
  int start() const;

  // Returns stopping index
  int stop() const;

  // Returns stopping index
  int stride() const;

  // Returns the number of values included within the range
  int size() const;

};


#endif
